Panda3D

Public Types | Public Member Functions | Static Public Member Functions | List of all members
EggPolysetMaker Class Reference

A specialization on EggBinMaker for making polysets that share the same basic rendering characteristic. More...

`#include "eggPolysetMaker.h"`

Inheritance diagram for EggPolysetMaker:

## Public Types
enum | BinNumber { BN_none = 0 , BN_polyset }
enum | Properties { P_has_texture = 0x001 , P_texture = 0x002 , P_has_material = 0x004 , P_material = 0x008 , P_has_poly_color = 0x010 , P_poly_color = 0x020 , P_has_poly_normal = 0x040 , P_has_vertex_normal = 0x080 , P_has_vertex_color = 0x100 , P_bface = 0x200 }

## Public Member Functions
virtual TypeHandle | force_init_type ()
virtual int | get_bin_number (const EggNode *node)
virtual TypeHandle | get_type () const
void | set_properties (int properties)
| Sets the set of properties that determines which polygons are allowed to be grouped together into a single polyset. More...
virtual bool | sorts_less (int bin_number, const EggNode *a, const EggNode *b)
| May be overridden in derived classes to create additional bins within a particular bin number, based on some arbitrary property of nodes. More...
Public Member Functions inherited from EggBinMaker
virtual bool | collapse_group (const EggGroup *group, int bin_number)
| May be overridden in derived classes to specify whether a particular group node, apparently redundant, may be safely collapsed out. More...
virtual std::string | get_bin_name (int bin_number, const EggNode *child)
| May be overridden in derived classes to define a name for each new bin, based on its bin number, and a sample child. More...
int | make_bins (EggGroupNode *root_group)
| The main entry point to EggBinMaker. More...
virtual void | prepare_node (EggNode *node)
| May be overridden in derived classes to perform some setup work as each node is encountered. More...
virtual | PT (EggBin) make_bin(int bin_number
Public Member Functions inherited from EggObject
| EggObject (const EggObject &copy)
virtual EggTransform * | as_transform ()
| Returns this object cross-cast to an EggTransform pointer, if it inherits from EggTransform, or NULL if it does not. More...
void | clear_user_data ()
| Removes *all* user data pointers from the node. More...
void | clear_user_data (TypeHandle type)
| Removes the user data pointer of the indicated type. More...
EggUserData * | get_user_data () const
| Returns the user data pointer most recently stored on this object, or NULL if nothing was previously stored. More...
EggUserData * | get_user_data (TypeHandle type) const
| Returns the user data pointer of the indicated type, if it exists, or NULL if it does not. More...
bool | has_user_data () const
| Returns true if a generic user data pointer has recently been set and not yet cleared, false otherwise. More...
bool | has_user_data (TypeHandle type) const
| Returns true if the user data pointer of the indicated type has been set, false otherwise. More...
EggObject & | operator= (const EggObject &copy)
void | set_user_data (EggUserData *user_data)
| Sets the user data associated with this object. More...
Public Member Functions inherited from TypedReferenceCount
| TypedReferenceCount (const TypedReferenceCount &copy)
void | operator= (const TypedReferenceCount &copy)
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer. More...
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer. More...
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type. More...
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly. More...
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type. More...
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object. More...
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise. More...
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack. More...
void | ref () const
| Explicitly increments the reference count. More...
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero. More...
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus. More...
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus. More...
virtual bool | unref () const
| Explicitly decrements the reference count. More...
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one. More...
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object. More...
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object. More...

## Static Public Member Functions
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from EggBinMaker
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from EggObject
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96. More...
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()

## Additional Inherited Members
Public Attributes inherited from EggBinMaker
virtual const EggNode * | child
virtual const EggNode EggGroup * | collapse_from
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count. More...

## Detailed Description

A specialization on EggBinMaker for making polysets that share the same basic rendering characteristic.

This really just defines the example functions described in the leading comment to EggBinMaker.

It makes some common assumptions about how polysets should be grouped; if these are not sufficient, you can always rederive your own further specialization of this class.

Definition at line 32 of file eggPolysetMaker.h.

## Member Function Documentation

## ◆ set_properties()

void EggPolysetMaker::set_properties | ( | int | properties | ) |

Sets the set of properties that determines which polygons are allowed to be grouped together into a single polyset.

This is the bitwise 'or' of all the properties that matter. If this is 0, all polygons (within a given group) will be lumped into a common polyset regardless of their properties.

Definition at line 33 of file eggPolysetMaker.cxx.

## ◆ sorts_less()

bool EggPolysetMaker::sorts_less | ( | int | bin_number,
|  | const EggNode * | a,
|  | const EggNode * | b
| ) |  |
| virtual

May be overridden in derived classes to create additional bins within a particular bin number, based on some arbitrary property of nodes.

This function establishes an arbitrary but fixed ordering between nodes; if two nodes do not sort to the same position, different bins are created for each one (with the same bin number on each bin).

Reimplemented from EggBinMaker.

Definition at line 54 of file eggPolysetMaker.cxx.

The documentation for this class was generated from the following files:

- panda/src/egg/eggPolysetMaker.h
- panda/src/egg/eggPolysetMaker.cxx